"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Job = void 0;
var perf_hooks_1 = require("perf_hooks");
var shortid_1 = require("shortid");
var stream_1 = require("stream");
var Job = /** @class */ (function () {
    function Job(processor, destinations, config) {
        if (config === void 0) { config = {}; }
        this.processor = processor;
        this.destinations = destinations;
        this.events = {};
        this.anyEvent = [];
        this.stopped = false;
        this.jobId = shortid_1.generate();
        this.settingReporterEvents = false;
        this.jobName = config === null || config === void 0 ? void 0 : config.jobName;
        this.reporters = config.reporters || [];
    }
    Job.prototype.stop = function (message) { };
    Job.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var i, readStream, errorMessage, e_1, err_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.settingReporterEvents = true;
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < this.reporters.length)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.reporters[i].report(this)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4:
                        this.settingReporterEvents = false;
                        this.stop = function (message) {
                            if (!_this.stopped) {
                                _this.stopped = true;
                                if (readStream && (readStream instanceof stream_1.Readable)) {
                                    readStream.emit('end');
                                    readStream.destroy();
                                }
                                errorMessage = message;
                            }
                        };
                        return [4 /*yield*/, this.emit('startProcessing', this.processor, this.destinations)];
                    case 5:
                        _a.sent();
                        if (!!this.stopped) return [3 /*break*/, 10];
                        _a.label = 6;
                    case 6:
                        _a.trys.push([6, 8, , 10]);
                        return [4 /*yield*/, this.processor.process(function (_readStream) {
                                var args = [];
                                for (var _i = 1; _i < arguments.length; _i++) {
                                    args[_i - 1] = arguments[_i];
                                }
                                return __awaiter(_this, void 0, void 0, function () {
                                    var results, j, processedRowCount, readStream_1, readStream_1_1, row, i, recordGeneratorFn, _a, _b, record, e_2_1, err_2, i, destination, toSend, e_3_1, err_3;
                                    var e_3, _c, e_2, _d;
                                    return __generator(this, function (_e) {
                                        switch (_e.label) {
                                            case 0:
                                                readStream = _readStream;
                                                return [4 /*yield*/, this.emit.apply(this, __spreadArrays(['startProcessingStream'], args))];
                                            case 1:
                                                _e.sent();
                                                _e.label = 2;
                                            case 2:
                                                _e.trys.push([2, 44, , 45]);
                                                if (!!this.stopped) return [3 /*break*/, 43];
                                                results = [];
                                                for (j = 0; j < this.destinations.length; j++) {
                                                    results[j] = [];
                                                }
                                                processedRowCount = 0;
                                                _e.label = 3;
                                            case 3:
                                                _e.trys.push([3, 35, 36, 41]);
                                                readStream_1 = __asyncValues(readStream);
                                                _e.label = 4;
                                            case 4: return [4 /*yield*/, readStream_1.next()];
                                            case 5:
                                                if (!(readStream_1_1 = _e.sent(), !readStream_1_1.done)) return [3 /*break*/, 34];
                                                row = readStream_1_1.value;
                                                return [4 /*yield*/, this.emit('startProcessingRow', row)];
                                            case 6:
                                                _e.sent();
                                                if (!!this.stopped) return [3 /*break*/, 25];
                                                i = 0;
                                                _e.label = 7;
                                            case 7:
                                                if (!(i < this.destinations.length)) return [3 /*break*/, 25];
                                                recordGeneratorFn = this.destinations[i].recordGenerator;
                                                if (!!recordGeneratorFn) return [3 /*break*/, 8];
                                                results[i].push(row);
                                                return [3 /*break*/, 24];
                                            case 8:
                                                _e.trys.push([8, 22, , 24]);
                                                _e.label = 9;
                                            case 9:
                                                _e.trys.push([9, 15, 16, 21]);
                                                _a = (e_2 = void 0, __asyncValues(recordGeneratorFn(row)));
                                                _e.label = 10;
                                            case 10: return [4 /*yield*/, _a.next()];
                                            case 11:
                                                if (!(_b = _e.sent(), !_b.done)) return [3 /*break*/, 14];
                                                record = _b.value;
                                                results[i].push(record);
                                                return [4 /*yield*/, this.emit('rowGenerated', i, record)];
                                            case 12:
                                                _e.sent();
                                                _e.label = 13;
                                            case 13: return [3 /*break*/, 10];
                                            case 14: return [3 /*break*/, 21];
                                            case 15:
                                                e_2_1 = _e.sent();
                                                e_2 = { error: e_2_1 };
                                                return [3 /*break*/, 21];
                                            case 16:
                                                _e.trys.push([16, , 19, 20]);
                                                if (!(_b && !_b.done && (_d = _a.return))) return [3 /*break*/, 18];
                                                return [4 /*yield*/, _d.call(_a)];
                                            case 17:
                                                _e.sent();
                                                _e.label = 18;
                                            case 18: return [3 /*break*/, 20];
                                            case 19:
                                                if (e_2) throw e_2.error;
                                                return [7 /*endfinally*/];
                                            case 20: return [7 /*endfinally*/];
                                            case 21: return [3 /*break*/, 24];
                                            case 22:
                                                err_2 = _e.sent();
                                                return [4 /*yield*/, this.emit('rowGenerationError', i, row, err_2)];
                                            case 23:
                                                _e.sent();
                                                return [3 /*break*/, 24];
                                            case 24:
                                                i++;
                                                return [3 /*break*/, 7];
                                            case 25: return [4 /*yield*/, this.emit('endProcessingRow')];
                                            case 26:
                                                _e.sent();
                                                i = 0;
                                                _e.label = 27;
                                            case 27:
                                                if (!(i < this.destinations.length)) return [3 /*break*/, 31];
                                                _e.label = 28;
                                            case 28:
                                                if (!(this.destinations[i].batchSize && results[i].length >= this.destinations[i].batchSize)) return [3 /*break*/, 30];
                                                destination = this.destinations[i];
                                                toSend = results[i].splice(0, destination.batchSize);
                                                return [4 /*yield*/, this.loadBatch(i, destination, toSend)];
                                            case 29:
                                                _e.sent();
                                                return [3 /*break*/, 28];
                                            case 30:
                                                i++;
                                                return [3 /*break*/, 27];
                                            case 31:
                                                processedRowCount++;
                                                if (!(this.processor.rowLimit === processedRowCount)) return [3 /*break*/, 33];
                                                return [4 /*yield*/, this.flushRows(results)];
                                            case 32:
                                                _e.sent();
                                                this.stop();
                                                return [3 /*break*/, 34];
                                            case 33: return [3 /*break*/, 4];
                                            case 34: return [3 /*break*/, 41];
                                            case 35:
                                                e_3_1 = _e.sent();
                                                e_3 = { error: e_3_1 };
                                                return [3 /*break*/, 41];
                                            case 36:
                                                _e.trys.push([36, , 39, 40]);
                                                if (!(readStream_1_1 && !readStream_1_1.done && (_c = readStream_1.return))) return [3 /*break*/, 38];
                                                return [4 /*yield*/, _c.call(readStream_1)];
                                            case 37:
                                                _e.sent();
                                                _e.label = 38;
                                            case 38: return [3 /*break*/, 40];
                                            case 39:
                                                if (e_3) throw e_3.error;
                                                return [7 /*endfinally*/];
                                            case 40: return [7 /*endfinally*/];
                                            case 41:
                                                if (!!this.stopped) return [3 /*break*/, 43];
                                                return [4 /*yield*/, this.flushRows(results)];
                                            case 42:
                                                _e.sent();
                                                _e.label = 43;
                                            case 43: return [3 /*break*/, 45];
                                            case 44:
                                                err_3 = _e.sent();
                                                e_1 = err_3;
                                                return [3 /*break*/, 45];
                                            case 45: return [4 /*yield*/, this.emit.apply(this, __spreadArrays(['endProcessingStream'], args))];
                                            case 46:
                                                _e.sent();
                                                return [2 /*return*/];
                                        }
                                    });
                                });
                            })];
                    case 7:
                        _a.sent();
                        if (e_1) {
                            throw e_1;
                        }
                        return [3 /*break*/, 10];
                    case 8:
                        err_1 = _a.sent();
                        return [4 /*yield*/, this.emit('processingError', err_1)];
                    case 9:
                        _a.sent();
                        return [3 /*break*/, 10];
                    case 10: return [4 /*yield*/, this.emit('endProcessing')];
                    case 11:
                        _a.sent();
                        if (errorMessage) {
                            throw new Error(errorMessage);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Job.prototype.on = function (eventName, event, extendedEvent) {
        var eventEntry = { event: event, extendedEvent: extendedEvent };
        if (!this.events[eventName]) {
            this.events[eventName] = [];
        }
        this.settingReporterEvents
            ? this.events[eventName].unshift(eventEntry)
            : this.events[eventName].push(eventEntry);
    };
    Job.prototype.onAny = function (event, extendedEvent) {
        var eventEntry = { event: event, extendedEvent: extendedEvent };
        this.settingReporterEvents
            ? this.anyEvent.unshift(eventEntry)
            : this.anyEvent.push(eventEntry);
    };
    Job.prototype.flushRows = function (rows) {
        return __awaiter(this, void 0, void 0, function () {
            var i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < this.destinations.length)) return [3 /*break*/, 4];
                        if (!rows[i].length) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.loadBatch(i, this.destinations[i], rows[i])];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Job.prototype.loadBatch = function (destinationIndex, destination, data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_4, err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!data.length) return [3 /*break*/, 18];
                        if (!destination.batchTransformer) return [3 /*break*/, 9];
                        return [4 /*yield*/, this.emit('transformingBatch', destinationIndex, data)];
                    case 1:
                        _a.sent();
                        if (!!this.stopped) return [3 /*break*/, 7];
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 5, , 7]);
                        return [4 /*yield*/, destination.batchTransformer(data)];
                    case 3:
                        data = _a.sent();
                        return [4 /*yield*/, this.emit('transformedBatch', destinationIndex, data)];
                    case 4:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 5:
                        err_4 = _a.sent();
                        return [4 /*yield*/, this.emit('transformingBatchError', destinationIndex, data, err_4)];
                    case 6:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 7: return [4 /*yield*/, this.emit('endTransformingBatch', destinationIndex)];
                    case 8:
                        _a.sent();
                        _a.label = 9;
                    case 9:
                        if (!(!destination.disableLoad && !this.stopped)) return [3 /*break*/, 18];
                        return [4 /*yield*/, this.emit('loadingBatch', destinationIndex, data)];
                    case 10:
                        _a.sent();
                        if (!!this.stopped) return [3 /*break*/, 16];
                        _a.label = 11;
                    case 11:
                        _a.trys.push([11, 14, , 16]);
                        return [4 /*yield*/, destination.loadBatch(data)];
                    case 12:
                        _a.sent();
                        return [4 /*yield*/, this.emit('loadedBatch', destinationIndex, data)];
                    case 13:
                        _a.sent();
                        return [3 /*break*/, 16];
                    case 14:
                        err_5 = _a.sent();
                        return [4 /*yield*/, this.emit('loadingBatchError', destinationIndex, data, err_5)];
                    case 15:
                        _a.sent();
                        return [3 /*break*/, 16];
                    case 16: return [4 /*yield*/, this.emit('endLoadingBatch', destinationIndex)];
                    case 17:
                        _a.sent();
                        _a.label = 18;
                    case 18: return [2 /*return*/];
                }
            });
        });
    };
    Job.prototype.emit = function (eventName) {
        var _a, _b, _c, _d;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var fn, bellboyEvent, i, i, err_6;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _e.trys.push([0, 11, , 12]);
                        fn = this.events[eventName];
                        bellboyEvent = {
                            eventName: eventName,
                            eventArguments: args,
                            timestamp: perf_hooks_1.performance.now() + perf_hooks_1.performance.timeOrigin,
                            jobStopped: this.stopped,
                            eventId: shortid_1.generate(),
                            jobId: this.jobId,
                            jobName: this.jobName,
                        };
                        if (!fn) return [3 /*break*/, 5];
                        i = 0;
                        _e.label = 1;
                    case 1:
                        if (!(i < fn.length)) return [3 /*break*/, 5];
                        return [4 /*yield*/, ((_a = fn[i].event) === null || _a === void 0 ? void 0 : _a.apply(this, args))];
                    case 2:
                        _e.sent();
                        return [4 /*yield*/, ((_b = fn[i].extendedEvent) === null || _b === void 0 ? void 0 : _b.apply(this, [bellboyEvent]))];
                    case 3:
                        _e.sent();
                        _e.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 1];
                    case 5:
                        i = 0;
                        _e.label = 6;
                    case 6:
                        if (!(i < this.anyEvent.length)) return [3 /*break*/, 10];
                        return [4 /*yield*/, ((_c = this.anyEvent[i].event) === null || _c === void 0 ? void 0 : _c.apply(this, __spreadArrays([eventName], args)))];
                    case 7:
                        _e.sent();
                        return [4 /*yield*/, ((_d = this.anyEvent[i].extendedEvent) === null || _d === void 0 ? void 0 : _d.apply(this, [bellboyEvent]))];
                    case 8:
                        _e.sent();
                        _e.label = 9;
                    case 9:
                        i++;
                        return [3 /*break*/, 6];
                    case 10: return [3 /*break*/, 12];
                    case 11:
                        err_6 = _e.sent();
                        console.error("Warning. Exception was thrown inside " + eventName + " event.", err_6);
                        return [3 /*break*/, 12];
                    case 12: return [2 /*return*/];
                }
            });
        });
    };
    return Job;
}());
exports.Job = Job;
