"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DirectoryProcessor = void 0;
var fs_1 = __importDefault(require("fs"));
var processor_1 = require("./processor");
var DirectoryProcessor = /** @class */ (function (_super) {
    __extends(DirectoryProcessor, _super);
    function DirectoryProcessor(config) {
        var _this = _super.call(this, config) || this;
        _this.files = [];
        if (!config.path && (!config.files || config.files.length === 0)) {
            throw new Error("No path or files specified.");
        }
        _this.path = config.path || '';
        var filePattern = "(.*?)";
        if (config.filePattern) {
            filePattern = config.filePattern;
        }
        if (!config.files || config.files.length === 0) {
            var dir = fs_1.default.readdirSync(_this.path);
            var regex_1 = new RegExp(filePattern, 'g');
            _this.files = dir.sort().filter(function (x) { return x.match(regex_1); });
        }
        else {
            _this.files = config.files;
        }
        return _this;
    }
    return DirectoryProcessor;
}(processor_1.Processor));
exports.DirectoryProcessor = DirectoryProcessor;
