"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExcelProcessor = void 0;
var path_1 = __importDefault(require("path"));
var xlstream_1 = require("xlstream");
var directory_processor_1 = require("./base/directory-processor");
var ExcelProcessor = /** @class */ (function (_super) {
    __extends(ExcelProcessor, _super);
    function ExcelProcessor(config) {
        var _this = _super.call(this, config) || this;
        _this.encoding = config.encoding;
        _this.hasHeader = config.hasHeader;
        _this.ignoreEmpty = config.ignoreEmpty === false ? false : true;
        _this.fillMergedCells = !!config.fillMergedCells;
        if (config.sheets) {
            _this.sheets = config.sheets;
        }
        else {
            _this.sheets = [0];
        }
        return _this;
    }
    ExcelProcessor.prototype.process = function (processStream) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, file, filePath, sheets, allSheets, i, readStream;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _i = 0, _a = this.files;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 11];
                        file = _a[_i];
                        filePath = path_1.default.join(this.path, file);
                        sheets = [];
                        if (!(this.sheets instanceof Function)) return [3 /*break*/, 4];
                        return [4 /*yield*/, xlstream_1.getWorksheets({ filePath: filePath })];
                    case 2:
                        allSheets = _b.sent();
                        return [4 /*yield*/, this.sheets(allSheets)];
                    case 3:
                        sheets = _b.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        sheets = this.sheets;
                        _b.label = 5;
                    case 5:
                        i = 0;
                        _b.label = 6;
                    case 6:
                        if (!(i < sheets.length)) return [3 /*break*/, 10];
                        return [4 /*yield*/, xlstream_1.getXlsxStream({
                                filePath: filePath,
                                sheet: sheets[i],
                                withHeader: this.hasHeader,
                                ignoreEmpty: this.ignoreEmpty,
                                fillMergedCells: this.fillMergedCells,
                                encoding: this.encoding,
                            })];
                    case 7:
                        readStream = _b.sent();
                        return [4 /*yield*/, processStream(readStream, file, filePath, sheets[i])];
                    case 8:
                        _b.sent();
                        _b.label = 9;
                    case 9:
                        i++;
                        return [3 /*break*/, 6];
                    case 10:
                        _i++;
                        return [3 /*break*/, 1];
                    case 11: return [2 /*return*/];
                }
            });
        });
    };
    return ExcelProcessor;
}(directory_processor_1.DirectoryProcessor));
exports.ExcelProcessor = ExcelProcessor;
