import { AxiosRequestConfig } from 'axios';
import { AuthorizationRequest, IDelimitedHttpProcessorConfig, IJsonHttpProcessorConfig, IXmlHttpProcessorConfig, processStream } from '../types';
import { Processor } from './base/processor';
export declare class HttpProcessor extends Processor {
    protected connection: AxiosRequestConfig;
    protected nextRequest: (() => Promise<any>) | undefined;
    protected jsonPath: RegExp | undefined;
    protected rowSeparator: string | undefined;
    protected dataFormat: 'json' | 'delimited' | 'xml';
    protected hasHeader: boolean;
    protected delimiter?: string;
    protected qualifier?: string;
    protected authorizationRequest?: AuthorizationRequest;
    protected saxOptions?: any;
    protected encoding?: string;
    constructor(config: IJsonHttpProcessorConfig | IDelimitedHttpProcessorConfig | IXmlHttpProcessorConfig);
    protected processHttpData(processStream: processStream, options: AxiosRequestConfig): Promise<void>;
    process(processStream: processStream): Promise<void>;
}
