/// <reference types="node" />
import { AxiosRequestConfig } from 'axios';
import { Transform } from 'stream';
import { AuthorizationRequest, DbTypes, IDbConnection } from './types';
export declare function getDb(databaseConfig: IDbConnection, dbType: DbTypes): Promise<any>;
export declare function closeDbConnection(databaseConfig: IDbConnection): Promise<void>;
export declare function getValueFromJSONChunk(): Transform;
export declare function removeCircularReferencesFromChunk(): Transform;
export declare function getDelimitedGenerator({ readStream, hasHeader, }: {
    readStream: any;
    hasHeader: boolean;
}): () => AsyncGenerator<{
    header: string[];
    arr: string[];
    obj: any;
    row: string;
}, void, unknown>;
export declare function applyHttpAuthorization(connection: AxiosRequestConfig, authorizationRequest?: AuthorizationRequest): Promise<void>;
